import React from 'react';
import { connect } from 'react-redux';
import { addItemToCart, removeCartItem } from '../actions/cart_actions';
import { incrementInventory, decrementInventory } from '../actions/inventory_actions';



let Cart = ({addItemToCart, removeCartItem, data, cartTotal }) => {
    
    const checkTotal = () => {
        if (cartTotal <= 0) {
            return;
        } else {
            removeCartItem();
        }
    }



    const products = data.variants.map((product, key) => 
        <div key={key}>
            <ul>
                <img src={product.image}></img>
                <p>{product.name}</p>
                <p>{product.desciption}</p>
                <button onClick={addItemToCart}>Add to cart</button>
                <button onClick={checkTotal}>Remove item</button>
            </ul>
        </div>
    )

    // debugger

    return (
        <div>
            <h3>CART</h3>
            <h4>Cart Total: {cartTotal}</h4>
            <div>{products}</div>
        </div>
    )
    
}


const mapSTP = (state) => {
    console.log(state)
    const { cartReducer, inventoryReducer } = state;
    return {
        data: cartReducer.data,
        cartTotal: cartReducer.cartTotal,
        productTotal: inventoryReducer.productTotal
    }
}



const mapDTP = (dispatch) => ({
    addItemToCart: () => { dispatch(addItemToCart()) },
    removeCartItem: () => { dispatch(removeCartItem()) },
    incrementInventory: (total) => { dispatch(incrementInventory(total)) },
    decrementInventory: (total) => { dispatch(decrementInventory(total)) }
})


Cart = connect(mapSTP, mapDTP)(Cart)

export default Cart;